/*
 * Partially implemented disassembler for Samsung SSP160x processors
 * (C) Copyright 2007-2008, Grazvydas "notaz" Ignotas
 */

#ifndef __INSTRS_HPP
#define __INSTRS_HPP

#include "ins.hpp"

/************************************************************************/
/* Instructions enumeration                                             */
/************************************************************************/
extern instruc_t Instructions[];
enum nameNum
{
	SSP_unknown = 0,   // Unknown Operation
	SSP_nop,

	// OP a, s; OP a, adr
	SSP_ld,
	SSP_sub,
	SSP_cmp,
	SSP_add,
	SSP_and,
	SSP_or,
	SSP_eor,

	// OP a, imm
	SSP_ldi,
	SSP_subi,
	SSP_cmpi,
	SSP_addi,
	SSP_andi,
	SSP_ori,
	SSP_eori,

	// OP simm
	SSP_subi_simm,
	SSP_cmpi_simm,
	SSP_addi_simm,
	SSP_andi_simm,
	SSP_ori_simm,
	SSP_eori_simm,

	SSP_call,
	SSP_bra,
	SSP_ld_pc,	// ld PC, imm
	SSP_ret,

	SSP_mod,
	SSP_mpys,
	SSP_mpya,
	SSP_mld,
	SSP_mset,

	SSP_last
};

#endif
